// Basis.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "stdbnx.h"
#include "Basis.h"

#include "MainFrm.h"
#include "BasisDoc.h"
#include "BasisView.h"
#include "TDoingAgent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBasisApp

BEGIN_MESSAGE_MAP(CBasisApp, CWinApp)
	//{{AFX_MSG_MAP(CBasisApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
//	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_NEW, OnMyFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBasisApp construction

CBasisApp::CBasisApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBasisApp object

CBasisApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBasisApp initialization

BOOL CBasisApp::InitInstance()
{
	int	i, j;
	
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	//AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CBasisDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CBasisView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	ParseCommandLine(m_tCmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(m_tCmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
#ifdef _DEBUG
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
#else
	m_pMainWnd->ShowWindow(SW_MINIMIZE);
#endif

	// get the document
	POSITION pos = GetFirstDocTemplatePosition();
	CDocTemplate* pDoc = GetNextDocTemplate(pos);
	pos = pDoc->GetFirstDocPosition();
	m_pDoc = (CBasisDoc*) pDoc->GetNextDoc(pos);

	// initialisation
	m_pParams = new TNetworkParams();
	m_pParams->SetPhi(0.0);
	m_pParams->SetGamma(0.1);
	m_pParams->SetDelta(0.0);
	m_pParams->SetBeta(0.0);
	m_pParams->SetTheta(2.0);
	m_pParams->SetThetaReduction(0.1);

	m_iNoOfProblems = 0;
	m_iLoop1 = 0;
	m_iLoop2 = 0;
	for (i = 0; i < GRID_SIZE; i++)
		for (j = 0; j < GRID_SIZE; j++)
			m_aabResult[i][j] = FALSE;
	return TRUE;
}

int CBasisApp::ExitInstance() 
{
	delete m_pParams;
	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBasisApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CBasisApp commands
void CBasisApp::OnMyFileNew()
{
	CWinApp::OnFileNew();

	// if a /team name parameter is passed to the application, then the agent
	// gets the name of the team and is directly connected to the default server
	if (m_tCmdInfo.GetHasTeamname())
	{
		TNetworkParams*		pParams;
		CSingleDocTemplate*	pDocTemplate;
		CBasisDoc*				pDoc;
		POSITION					pos = GetFirstDocTemplatePosition();
		
		pDocTemplate = (CSingleDocTemplate*) GetNextDocTemplate(pos);
		pos = pDocTemplate->GetFirstDocPosition();
		
		pDoc = (CBasisDoc*) pDocTemplate->GetNextDoc(pos);

		// set if this is a coach
		if (m_tCmdInfo.m_isCoach)
			pDoc->SetIsCoach(m_tCmdInfo.m_isCoachOnline);

		// set the server address
		if (m_tCmdInfo.m_bHasServerAddress)
			pDoc->SetServerAddress(m_tCmdInfo.m_strServerAddress);

		// set the server port
		if (m_tCmdInfo.m_bHasPort)
			pDoc->SetServerPort(m_tCmdInfo.m_iPort);

		// set monitor address
		if (m_tCmdInfo.m_bHasMonitorAddress)
			pDoc->SetMonitorAddress(m_tCmdInfo.m_strMonitorAddress, m_tCmdInfo.m_uiMonitorPort);

		// set autorun parameter
		pDoc->SetAutorun(m_tCmdInfo.m_bAutorun, m_tCmdInfo.m_iAutorunID, m_tCmdInfo.m_iPlayerID);

		if (m_tCmdInfo.GetHasType())
			// a knowledge type is specified, so set it
			pDoc->SetKnowledgeType(m_tCmdInfo.GetType());

		// set the rule file
		if (m_tCmdInfo.m_bHasRuleFile)
			pDoc->SetRuleFile(m_tCmdInfo.m_strRuleFile);

		// set the teamname
		pDoc->SetTeamname(m_tCmdInfo.GetTeamname());
		
		// fuzzy propositions
		if (m_tCmdInfo.m_bHasFuzzy)
			pDoc->SetUseFuzzyValues(TRUE);
		else
			pDoc->SetUseFuzzyValues(FALSE);

		// goal tracking
		if (m_tCmdInfo.m_bHasGoalTracking)
			pDoc->SetGoalTrackingOn(TRUE);
		else
			pDoc->SetGoalTrackingOn(FALSE);

		// activation area adaption
		if (m_tCmdInfo.m_bHasAdaptActivationArea)
			pDoc->SetAdaptActivationAreaOn(TRUE);
		else
			pDoc->SetAdaptActivationAreaOn(FALSE);

		// check parameters
		pParams = pDoc->GetNetworkParams();
		if (m_tCmdInfo.m_bHasPhi)
		{
			pParams->SetPhi(m_tCmdInfo.m_dPhi);
			// phi is not used by Dorer Networks, so we use it as noise param
			pDoc->SetNoise(m_tCmdInfo.m_dPhi);
		}
		if (m_tCmdInfo.m_bHasGamma)
			pParams->SetGamma(m_tCmdInfo.m_dGamma);
		if (m_tCmdInfo.m_bHasDelta)
			pParams->SetDelta(m_tCmdInfo.m_dDelta);
		if (m_tCmdInfo.m_bHasPi)
			pParams->SetBeta(m_tCmdInfo.m_dPi);
		if (m_tCmdInfo.m_bHasTheta)
			pParams->SetTheta(m_tCmdInfo.m_dTheta);
		if (m_tCmdInfo.m_bHasThetaReduction)
			pParams->SetThetaReduction(m_tCmdInfo.m_dThetaReduction);
		if (m_tCmdInfo.m_bHasFuzzyRound)
		{
			pParams->SetFuzzyRound(m_tCmdInfo.m_dFuzzyRound);
			pDoc->SetFuzzyRound(m_tCmdInfo.m_dFuzzyRound);
		}
			

		// connect the agent to the server and start it
		if (m_tCmdInfo.m_isReconnect && !m_tCmdInfo.m_isCoach)
		{
			pDoc->SetNumber(m_tCmdInfo.m_reconnectNumber);
			pDoc->ReConnect();
		}
		else
			pDoc->Connect();
	}
}

BOOL CBasisApp::OnIdle(LONG lCount) 
{
	// only for blocksworld
	BOOL	bGoOn = CWinApp::OnIdle(lCount);
	int	i;
	int	j;

	if (!m_pDoc->GetRunning() || !m_pDoc->IsBlocksworld())
		return bGoOn;

	// do further processing
	bGoOn = TRUE;

	// call processing
	if (m_pDoc->PerformCycle(m_pParams, MAX_STEPS))
	{
		// reached goal, so store parameters and go to next setting
		m_aabResult[m_iLoop1][m_iLoop2] = TRUE;
	}
	else
	{
		// we did not reach the goal yet
	}
	
	m_pDoc->ResetNetwork();
	m_iLoop2++;
	if (m_iLoop2 >= GRID_SIZE)
	{
		m_iLoop2 = 0;
		m_iLoop1++;
		// gamma starts from 0.1 so only GRID_SIZE - 1 runs
		if (m_iLoop1 >= GRID_SIZE - 1)
		{
			// finished
			bGoOn = FALSE;
			m_pDoc->StopAgent();
			m_iNoOfProblems++;
			WriteResultsToFile();

			// reinitialize variables
			m_pParams->SetGamma(0.1);
			m_pParams->SetDelta(0.0);
			m_iLoop1 = 0;
			m_iLoop2 = 0;
			for (i = 0; i < GRID_SIZE; i++)
				for (j = 0; j < GRID_SIZE; j++)
					m_aabResult[i][j] = FALSE;
		}
	}

	// set the parameters
	m_pParams->SetGamma((double)m_iLoop1 * 0.1 + 0.1);
	m_pParams->SetDelta((double)m_iLoop2 * 0.1);

	return bGoOn;
}


void CBasisApp::WriteResultsToFile()
{
	int		i;
	int		j;
	CFile		file;
	CString	buffer;
	CString	filename;

	// get the filename
	filename.Format("%s%03d.dat", FILENAME, m_iNoOfProblems); 

	// open file and archive for result, which is appended
	if (file.Open(filename, CFile::modeCreate | CFile::modeWrite) == 0)
		return;

	for (i = 0; i < GRID_SIZE - 1; i++)
	{
		for (j = 0; j < GRID_SIZE; j++)
		{
			buffer.Format("%d, ", m_aabResult[i][j]);
			file.Write(buffer, buffer.GetLength());
		}
		// write newline
		buffer.Format("\r\n");
		file.Write(buffer, buffer.GetLength());
	}

	file.Close();
}
