// DNetworkParamsSlider.cpp : implementation file
//

#include "stdafx.h"
#include "NetworkHeader.h"
#include "TNetworkParams.h"
#include "DNetworkParamsSlider.h"

#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DNetworkParamsSlider dialog


DNetworkParamsSlider::DNetworkParamsSlider(CWnd* pParent /*=NULL*/, TNetworkParams* params)
	: CDialog(DNetworkParamsSlider::IDD, pParent)
{
	m_pParams = params;

	//{{AFX_DATA_INIT(DNetworkParamsSlider)
	m_dFuzzyRound = 0.0;
	//}}AFX_DATA_INIT
}


void DNetworkParamsSlider::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DNetworkParamsSlider)
	DDX_Control(pDX, IDC_SLIDER_THETAREDUC_MAES, m_cThetaReduction);
	DDX_Control(pDX, IDC_SLIDER_THETA_MAES, m_cTheta);
	DDX_Control(pDX, IDC_EDIT_THETAREDUC_MAES, m_edThetaReduction);
	DDX_Control(pDX, IDC_EDIT_THETA_MAES, m_edTheta);
	DDX_Control(pDX, IDC_EDIT_PI_MAES, m_edPi);
	DDX_Control(pDX, IDC_EDIT_PHI_MAES, m_edPhi);
	DDX_Control(pDX, IDC_EDIT_GAMMA_MAES, m_edGamma);
	DDX_Control(pDX, IDC_EDIT_DELTA_MAES, m_edDelta);
	DDX_Control(pDX, IDC_SLIDER_PI_MAES, m_cPi);
	DDX_Control(pDX, IDC_SLIDER_PHI_MAES, m_cPhi);
	DDX_Control(pDX, IDC_SLIDER_GAMMA_MAES, m_cGamma);
	DDX_Control(pDX, IDC_SLIDER_DELTA_MAES, m_cDelta);
	DDX_Text(pDX, IDC_EDIT_FUZZY, m_dFuzzyRound);
	DDV_MinMaxDouble(pDX, m_dFuzzyRound, 0., 1.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DNetworkParamsSlider, CDialog)
	//{{AFX_MSG_MAP(DNetworkParamsSlider)
	ON_WM_HSCROLL()
	ON_EN_KILLFOCUS(IDC_EDIT_DELTA_MAES, OnKillfocusEditDelta)
	ON_EN_KILLFOCUS(IDC_EDIT_GAMMA_MAES, OnKillfocusEditGamma)
	ON_EN_KILLFOCUS(IDC_EDIT_PHI_MAES, OnKillfocusEditPhi)
	ON_EN_KILLFOCUS(IDC_EDIT_PI_MAES, OnKillfocusEditPi)
	ON_EN_KILLFOCUS(IDC_EDIT_THETA_MAES, OnKillfocusEditTheta)
	ON_EN_KILLFOCUS(IDC_EDIT_THETAREDUC_MAES, OnKillfocusEditThetareduc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL DNetworkParamsSlider::SetEditValue(CEdit* edit, CSliderCtrl* slider, double &value
													, double min, double max, double range)
{
	TCHAR		szBuffer[32];
	CString	buffer;
	char*		endptr;
	double	temp;
	
	// get the content of the edit control and convert the string into a double
	edit->GetWindowText(szBuffer, 30);
	temp = strtod( szBuffer, &endptr );
	if (((temp == 0.0) && (szBuffer[0] != '0')) 
			|| (temp < min) || (temp > max))
	{
		// invalid input specified
		AfxMessageBox("Value not valid !");
		buffer.Format("%4.2f", value);
		edit->SetWindowText(buffer);
		return FALSE;
	}
	else
	{
		// keep the new value
		value = temp;
		slider->SetPos((int) (value * range));
		return TRUE;
	}
}



/////////////////////////////////////////////////////////////////////////////
// DNetworkParamsSlider message handlers

BOOL DNetworkParamsSlider::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString	buffer;

	// pi 
	m_cPi.SetRangeMin((int) m_dMin);
	m_cPi.SetRangeMax((int) (m_dMaxBeta * m_dRange));
	m_cPi.ClearSel();
	m_cPi.SetPos((int) (m_dPi * m_dRange));
	buffer.Format("%4.2f", m_dPi);
	m_edPi.SetWindowText(buffer);
	
	// phi 
	m_cPhi.SetRangeMin((int) m_dMin);
	m_cPhi.SetRangeMax((int) (m_dMax * m_dRange));
	m_cPhi.ClearSel();
	m_cPhi.SetPos((int) (m_dPhi * m_dRange));
	buffer.Format("%4.2f", m_dPhi);
	m_edPhi.SetWindowText(buffer);
	
	// gamma 
	m_cGamma.SetRangeMin((int) (m_dMinGamma * m_dRange));
	m_cGamma.SetRangeMax((int) (m_dMax * m_dRange));
	m_cGamma.ClearSel();
	m_cGamma.SetPos((int) (m_dGamma * m_dRange));
	buffer.Format("%4.2f", m_dGamma);
	m_edGamma.SetWindowText(buffer);
	
	// delta maes
	m_cDelta.SetRangeMin((int) m_dMin);
	m_cDelta.SetRangeMax((int) (m_dMax * m_dRange));
	m_cDelta.ClearSel();
	m_cDelta.SetPos((int) (m_dDelta * m_dRange));
	buffer.Format("%4.2f", m_dDelta);
	m_edDelta.SetWindowText(buffer);
	
	// theta maes
	m_cTheta.SetRangeMin((int) m_dMin);
	m_cTheta.SetRangeMax((int) (m_dMax * m_dRange));
	m_cTheta.ClearSel();
	m_cTheta.SetPos((int) (m_dTheta * m_dRange));
	buffer.Format("%4.2f", m_dTheta);
	m_edTheta.SetWindowText(buffer);
	
	// theta reduction maes
	m_cThetaReduction.SetRangeMin((int) m_dMin);
	m_cThetaReduction.SetRangeMax((int) (m_dMaxThetaReduction * m_dRange));
	m_cThetaReduction.ClearSel();
	m_cThetaReduction.SetPos((int) (m_dThetaReduction * m_dRange));
	buffer.Format("%4.2f", m_dThetaReduction);
	m_edThetaReduction.SetWindowText(buffer);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DNetworkParamsSlider::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString	buffer;

	if ((CSliderCtrl *)pScrollBar == &m_cPi)
	{
		// pi maes
		m_dPi = (double) m_cPi.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dPi);
		m_edPi.SetWindowText(buffer);
		m_pParams->SetNetworkPi(m_dPi);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_cPhi)
	{
		// phi maes
		m_dPhi = (double) m_cPhi.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dPhi);
		m_edPhi.SetWindowText(buffer);
		m_pParams->SetPhi(m_dPhi);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_cGamma)
	{
		// gamma maes
		m_dGamma = (double) m_cGamma.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dGamma);
		m_edGamma.SetWindowText(buffer);
		m_pParams->SetGamma(m_dGamma);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_cDelta)
	{
		// delta maes
		m_dDelta = (double) m_cDelta.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dDelta);
		m_edDelta.SetWindowText(buffer);
		m_pParams->SetDelta(m_dDelta);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_cTheta)
	{
		// theta maes
		m_dTheta = (double) m_cTheta.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dTheta);
		m_edTheta.SetWindowText(buffer);
		m_pParams->SetTheta(m_dTheta);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_cThetaReduction)
	{
		// theta Reduction maes
		m_dThetaReduction = (double) m_cThetaReduction.GetPos() / m_dRange;
		buffer.Format("%4.2f", m_dThetaReduction);
		m_edThetaReduction.SetWindowText(buffer);
		m_pParams->SetThetaReduction(m_dThetaReduction);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void DNetworkParamsSlider::OnKillfocusEditDelta() 
{
	if (SetEditValue(&m_edDelta, &m_cDelta, m_dDelta, m_dMin, m_dMax, m_dRange))
		m_pParams->SetDelta(m_dDelta);
}

void DNetworkParamsSlider::OnKillfocusEditGamma() 
{
	if (SetEditValue(&m_edGamma, &m_cGamma, m_dGamma, m_dMinGamma, m_dMax, m_dRange))
		m_pParams->SetGamma(m_dGamma);
}

void DNetworkParamsSlider::OnKillfocusEditPhi() 
{
	if (SetEditValue(&m_edPhi, &m_cPhi, m_dPhi, m_dMin, m_dMax, m_dRange))
		m_pParams->SetPhi(m_dPhi);
}

void DNetworkParamsSlider::OnKillfocusEditPi() 
{
	if (SetEditValue(&m_edPi, &m_cPi, m_dPi, m_dMin, m_dMaxBeta, m_dRange))
		m_pParams->SetNetworkPi(m_dPi);
}


void DNetworkParamsSlider::OnKillfocusEditTheta() 
{
	if (SetEditValue(&m_edTheta, &m_cTheta, m_dTheta, m_dMin, m_dMax, m_dRange))
		m_pParams->SetTheta(m_dTheta);
}

void DNetworkParamsSlider::OnKillfocusEditThetareduc() 
{
	if (SetEditValue(&m_edThetaReduction, &m_cThetaReduction, m_dThetaReduction, m_dMin, m_dMaxThetaReduction, m_dRange))
		m_pParams->SetThetaReduction(m_dThetaReduction);
}
