// TAct.cpp: implementation of the TAct class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NetworkHeader.h"
#include "TAction.h"
#include "TAct.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]=__FILE__;
	#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TAct::TAct()
{
	m_pActions = new CObList();
}

TAct::~TAct()
{
	while (!m_pActions->IsEmpty())
		delete m_pActions->RemoveHead();
	delete m_pActions;
}

/*-----------------------------------------------------------------------------
Function: TAction TAct::GetAction(LPCTSTR name)
Date    : 14.01.98
-------------------------------------------------------------------------------
Parameter: name of the Action
Returnval: pointer to the action with name name
Description: searches for the Action in the array of Action names. 
-----------------------------------------------------------------------------*/
TAction* TAct::GetAction(LPCTSTR name)
{	
	POSITION		pos = m_pActions->GetHeadPosition();
	CString		strName = name;
	TAction*		pAction;

	// if the name is actionxxx, we map it to action
	if (strName.Find("action") == 0)
		strName = "action";

	while (pos != NULL)
	{
		pAction = (TAction*) m_pActions->GetNext(pos);
		if((pAction->GetName().CompareNoCase(strName)) == 0)
			return pAction;
	}
	return NULL;
}

/*-----------------------------------------------------------------------------
Function: void TAct::AddAction(LPCTSTR name, CObject* pObj, PCallBackAction pAction)
Date    : 22.02.99
-------------------------------------------------------------------------------
Parameter: name of the action
			  pointer to the object containing the action function
			  pointer to the action function
Returnval: number of actions in factory
Description: adds an action to this action factory
-----------------------------------------------------------------------------*/
int TAct::AddAction(LPCTSTR name, CObject* pObj, PCallBackAction pCall)
{
	TAction* pAction;

	pAction = new TAction(name, m_pActions->GetCount(), pObj, pCall);
	m_pActions->AddTail(pAction);
	return m_pActions->GetCount();	
}
