// TAction.h: interface for the TAction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TACTION_H__B07864C1_CA45_11D2_A173_006008E88C8E__INCLUDED_)
#define AFX_TACTION_H__B07864C1_CA45_11D2_A173_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


/*-----------------------------------------------------------------------------
Class   : TAction
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: CObject

Description: class to deal with action callbacks
-----------------------------------------------------------------------------*/

class TAction : public CObject  
{
	public:
		TAction(LPCTSTR name, int index, CObject* pObj, PCallBackAction pFn);
		virtual ~TAction();

		void		SetAction(LPCTSTR name, int index, CObject* pObj, PCallBackAction pFn);
		void		PerformAction(double activation, double defaultActivation);
		CString	GetName(void) { return m_strName; };
		int		GetIndex() const { return m_iIndex; };
		double	GetDecisiveness() const { return m_dDecisiveness; };
		long		GetNoOfActionPerformed() const { return m_lNoOfActionPerformed; };

	protected:
		CString				m_strName;
		int					m_iIndex;
		PCallBackAction	m_pAction;
		CObject*				m_pObject;

		double			m_dMinActivation;
		double			m_dMaxActivation;
		double			m_dMeanActivation;
		double			m_dVarianz;
		long				m_lNoOfActionPerformed;
		double			m_dDecisiveness;
};

#endif // !defined(AFX_TACTION_H__B07864C1_CA45_11D2_A173_006008E88C8E__INCLUDED_)
