// TConnection.h: interface for the TConnection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TDORERCONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TDORERCONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TConnection.h"

class TProposition;
class TScreenParamsNetwork;
class TEnergySpreader;
class TNetworkParams;

/*-----------------------------------------------------------------------------
Class   : Dorer Connections
Date    : 19.11.98
-------------------------------------------------------------------------------
Description: special classes to treat Dorer connections
-----------------------------------------------------------------------------*/

class TDorerSituationLink : public TConnection
{
	public:
		TDorerSituationLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
};


class TDorerGoalLink : public TConnection
{
	public:
		TDorerGoalLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
};


class TDorerProtectedGoalLink : public TConnection
{
	public:
		TDorerProtectedGoalLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DOT, 1, cCol); };
};


class TDorerSuccessorLink : public TConnection
{
	public:
		TDorerSuccessorLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DrawLink(CDC* pDC, TScreenParamsNetwork* pScreen) { DrawInternalLink(pDC, pScreen); };
		virtual	int		GetBending() { return TConnection::GetBending() + 10; };
};


class TDorerPredecessorLink : public TConnection
{
	public:
		TDorerPredecessorLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DrawLink(CDC* pDC, TScreenParamsNetwork* pScreen) { DrawInternalLink(pDC, pScreen); };
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DASHDOT, 1, cCol); };
		virtual	int		GetBending() { return TConnection::GetBending() + 5; };
};


class TDorerConflictorLink : public TConnection
{
	public:
		TDorerConflictorLink(TNetworkParams* params, TProposition* src, TProposition *dest);

		virtual double		GetActivation();
		virtual BOOL		IsDrawn(TScreenParamsNetwork* pScreen);
		virtual void		SetMaxActivation();
		virtual void		DrawLink(CDC* pDC, TScreenParamsNetwork* pScreen) { DrawInternalLink(pDC, pScreen); };
		virtual void		DoCreatePen(CPen& pen, COLORREF cCol) { pen.CreatePen(PS_DOT, 1, cCol); };
};

#endif // !defined(AFX_TDORERCONNECTION_H__76B7A462_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
