// TMaesCompetence.h: interface for the TMaesCompetence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TMaesCompetence_H__76B7A465_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TMaesCompetence_H__76B7A465_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TCompetence.h"

class TProposition;
class TGoal;
class TConnection;
class TNetworkParams;
class TGoalTrack;

/*-----------------------------------------------------------------------------
Class   : TMaesCompetence
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: TEnergySpreader

Description: represents a competence module, a module of level 2
-----------------------------------------------------------------------------*/

class TMaesCompetence : public TCompetence
{
	public:
		TMaesCompetence(TNetworkParams* params, LPCTSTR name, int iNoOfRules);
		virtual ~TMaesCompetence();

		virtual void	CalculateActivation(int iNoOfModules = 0, double dSumOfActivation = 0.0);
		virtual void	CalculateExecutability();
		virtual void	CalculateSpreading();
		virtual double	GetActivationAndExecutability();
		virtual void	ExecuteModule(double activation);

		virtual void	AddPropositionLink(TProposition* source, TProposition* dest);
		virtual void	AddGoalLink(TProposition* source, TProposition* prop);
		virtual void	AddProtectedGoalLink(TProposition* source, TProposition* prop);
		virtual void	AddSuccessor(TProposition* source, TProposition* dest);
		virtual void	AddPredecessor(TProposition* source, TProposition* dest);
		virtual void	AddConflictor(TProposition* source, TProposition* dest);
};

#endif // !defined(AFX_TMaesCompetence_H__76B7A465_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
