// TMaesKnowledge.h: interface for the TMaesKnowledge class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TMAESKNOWLEDGE_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TMAESKNOWLEDGE_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TBehaviorNetwork.h"

class TCompetence;
class TNetworkView;
class TRuleView;

/*-----------------------------------------------------------------------------
Class   : TMaesNetwork 
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: TBehaviorNetwork
Description: represents the knowledge of an agent containing the three levels
				 of cognition: 
				 cognitivly inpenetrable perception and action
				 competence modules
				 goals and goal management
				 implementation of Maes Agent Network Architecture (ANA) extended
				 to use multivalued propositions
-----------------------------------------------------------------------------*/

class DLL_CLASS TMaesNetwork : public TBehaviorNetwork
{
	public:
		TMaesNetwork(TNetworkView* pNView, TRuleView* pRView);
		virtual ~TMaesNetwork();

		// public methods
		virtual void	Initialize();
		virtual double	DoActivationSpreading();
		virtual void	ParamsDialog();

	protected:
		virtual TCompetence*	CreateNewCompetence();
		virtual void			CalculateSpreading();
		virtual double	GetActivationSum() const;

		double	m_dActivationSum;
};

#endif // !defined(AFX_TMAESKNOWLEDGE_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_)
