// TPercept.h: interface for the TPercept class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TPERCEPT_H__76B7A466_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TPERCEPT_H__76B7A466_8821_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TWorldState;
class TScreenParamsNetwork;

/*-----------------------------------------------------------------------------
Class   : TPercept
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: CObject
Description: represents a percept of the agent
-----------------------------------------------------------------------------*/

class TPercept : public CObject
{
	public:
		TPercept();
		virtual ~TPercept();

		// public methods
		void				InitializeAll();
		int				AddPerception(LPCTSTR name, CObject* pObj, PCallBackPerception pCallback);
		void				CalculateAllActivations();
		TWorldState*	GetPerception(LPCTSTR name);
		void				SetAllCoordinates(TScreenParamsNetwork* pScreen);
		void				SetAllNormCoordinates(CPoint coord, CSize stretch, int iMaxX);
		void				DrawAll(CDC* pDC, TScreenParamsNetwork* pScreen);
		POSITION			GetFirstPerceptionPosition() { return m_pFactoryObjects->GetHeadPosition(); };
		TWorldState*	GetNextPerception(POSITION& pos) { return (TWorldState*) m_pFactoryObjects->GetNext(pos); };
		void				WriteActivationDistribution(CArchive& ar);

		void				SetUseFuzzyValues(BOOL val);
		BOOL				GetUseFuzzyValues() const; 
		void				SetFuzzyRound(double val);

	protected:

		CObList*				m_pFactoryObjects;
};

#endif // !defined(AFX_TPERCEPT_H__76B7A466_8821_11D1_B242_0000C09B5CBE__INCLUDED_)
