// TProposition.h: interface for the TProposition class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TPROPOSITION_H__B6B1C1C3_8CBF_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TPROPOSITION_H__B6B1C1C3_8CBF_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


class TWorldState;
class TEnergySpreader;

/*-----------------------------------------------------------------------------
Class   : TProposition
Date    : 14.01.98
-------------------------------------------------------------------------------
Base Class: CObject
Description: handels the index and a double value of propositions and is used
				 as preconditions, effects and actions
-----------------------------------------------------------------------------*/

class TProposition : public CObject  
{
	public:
		TProposition();
		TProposition(TEnergySpreader* module, TWorldState* state, double value, BOOL neg) 
						{ SetProposition(module, state, value, neg); };
		virtual ~TProposition();

		// set and gets
		void		SetProposition(TEnergySpreader* module, TWorldState* state, double value
										, BOOL negated = FALSE);
		TEnergySpreader* GetModule() { return m_pModule; };
		void		SetWorldState();
		TWorldState* GetWorldState() { return m_pWorldState; };
		void		SetValue(double val);
		double	GetValue() const;
		double	GetWeigh() { return m_tWeigh; };
		BOOL		IsNegated() const { return m_bNegated; };
		BOOL		IsSame(TProposition* prop) const { return (m_pWorldState == prop->GetWorldState()); };
		BOOL		IsIdentic(TProposition* prop) const { return (IsSame(prop) && (m_bNegated == prop->IsNegated())); };
		BOOL		IsInvers(TProposition* prop) const { return (IsSame(prop) && (m_bNegated != prop->IsNegated())); };
		CString	ToString();

	private:
		TEnergySpreader*	m_pModule;		// module that contains the proposition

		TWorldState*		m_pWorldState; // pointer to the object containing the value of the prop
		double				m_tWeigh;		// for expectation or importance
		BOOL					m_bNegated;		// true for proposition with 'not'
};

#endif // !defined(AFX_TPROPOSITION_H__B6B1C1C3_8CBF_11D1_B242_0000C09B5CBE__INCLUDED_)
