// TResource.h: interface for the TResource class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRESOURCE_H__63957381_F314_11D2_A173_006008E88C8E__INCLUDED_)
#define AFX_TRESOURCE_H__63957381_F314_11D2_A173_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TWorldState.h"

/*-----------------------------------------------------------------------------
Class   : TResource
Date    : 15.04.99
-------------------------------------------------------------------------------
Base Class: TEnergySpreader
Description: class representing a resource node of the network used to coordinate
				 parallel action selection
-----------------------------------------------------------------------------*/

class TResource : public TWorldState
{
	public:
		TResource(LPCTSTR name, int index, CObject* pObj, PCallBackPerception pCall
					, int iMaxAvail);
		virtual ~TResource();

		void	ReduceActivationLevel(double dDeltaTheta);
		void	ResetActivationLevel(double dTheta);
		void	ReduceAmountAvailable(int iReduction);
		void	IncreaseAmountAvailable(int iIncrease);
		void	ResetAmountAvailable() { m_iAmountAvailable = m_iMaxAvailable; };

		// attributes
		int	GetAmountAvailable() const { return m_iAmountAvailable; };

	private:

		int	m_iMaxAvailable;
		int	m_iAmountAvailable;
};

#endif // !defined(AFX_TRESOURCE_H__63957381_F314_11D2_A173_006008E88C8E__INCLUDED_)
