#if !defined(AFX_TRuleView_H__D6818661_8D83_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TRuleView_H__D6818661_8D83_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TRuleView.h : header file
//

class TBehaviorNetwork;

/*-----------------------------------------------------------------------------
Class   : TRuleView
Date    : 15.01.98
-------------------------------------------------------------------------------
Base Class: CEditView
Description: class to display a rule file
-----------------------------------------------------------------------------*/

class DLL_CLASS TRuleView : public CEditView
{
protected:
	TRuleView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(TRuleView)

// Attributes
private:

	CString				m_strFileName;
	BOOL					m_bNoGraphics;
	BOOL					m_bHaveStandardFile;
	TBehaviorNetwork* m_pKnowledge;

// Operations
public:

	BOOL		OpenFile(BOOL bAskForName = TRUE);
	BOOL		OpenStandardFile(LPCTSTR filename);
	BOOL		OpenCurrentFile();
	void		Parse();
	void		InsertString(LPCTSTR name);

	void		SetBehaviorNetwork(TBehaviorNetwork* pKnow);
	void		SetNoGraphics(BOOL val);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TRuleView)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~TRuleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(TRuleView)
	afx_msg void OnUpdateFileOpenRules(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenRules();
	afx_msg void OnFileSaveAsRules();
	afx_msg void OnUpdateFileSaveAsRules(CCmdUI* pCmdUI);
	afx_msg void OnFileSaveRules();
	afx_msg void OnUpdateFileSaveRules(CCmdUI* pCmdUI);
	afx_msg void OnParseRules();
	afx_msg void OnUpdateParseRules(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRuleView_H__D6818661_8D83_11D1_B242_0000C09B5CBE__INCLUDED_)
