// GeneticAlgorithm.h: interface for the GeneticAlgorithm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENETICALGORITHM_H__034C0CC1_A4BD_4C3F_A595_BF799FE410D9__INCLUDED_)
#define AFX_GENETICALGORITHM_H__034C0CC1_A4BD_4C3F_A595_BF799FE410D9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define SIZE_OF_POPULATION	20
#define SIZE_OF_PARENTS		10

class GeneticCode;

class GeneticAlgorithm  : public CObject 
{
   DECLARE_SERIAL( GeneticAlgorithm )

	public:
		GeneticAlgorithm();
		virtual ~GeneticAlgorithm();

		void			Serialize( CArchive& archive );
		void			AddGeneticCode(GeneticCode* code) { m_population->AddTail(code); };
		void			GenerateNewPopulationFromScratch(GeneticCode* code);
		void			GenerateNewPopulationFromOld();
		GeneticCode*	OrderAndGetBest();
		void			GetFirstCodePosition() { m_currentCodePosition = m_population->GetHeadPosition(); };
		GeneticCode*	GetNextCode();
		CString			ToString();

	private:
		void	DeletePopulation();
		void	OrderByQuality();

		CObList*	m_population;
		POSITION	m_currentCodePosition;

};

#endif // !defined(AFX_GENETICALGORITHM_H__034C0CC1_A4BD_4C3F_A595_BF799FE410D9__INCLUDED_)
