// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "stdbnx.h"
#include "Basis.h"

#include "MainFrm.h"
#include "BasisDoc.h"
#include "BasisView.h"
#include "TPerceptionView.h"
#include "TDoingAgent.h"
#include "TCoachAgent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_TEST_RECIEVE, OnTestRecieve)
	ON_COMMAND(ID_VIEW_TOOLBAR_PERCEPTION, OnViewToolbarPerception)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR_PERCEPTION, OnUpdateViewToolbarPerception)
	ON_COMMAND(ID_VIEW_ALL_BARS, OnViewAllBars)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ALL_BARS, OnUpdateViewAllBars)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_ACTION, OnUpdateAction)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_TEAM, OnUpdateTeam)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_PLAYER, OnUpdatePlayer)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_RULES, OnUpdateRules)
	ON_CBN_SELENDOK(IDC_EDITBAR_ACTIONBOX, OnComboSelection)
	ON_CBN_DROPDOWN(IDC_EDITBAR_ACTIONBOX, OnComboDropDown)
	ON_CBN_SELENDOK(IDC_EDITBAR_PERCEPTIONBOX, OnComboPerceptionSelection)
	ON_CBN_DROPDOWN(IDC_EDITBAR_PERCEPTIONBOX, OnComboPerceptionDropDown)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_ACTION,
	ID_INDICATOR_TEAM,
	ID_INDICATOR_PLAYER,
	ID_INDICATOR_RULES
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_iStamina = 0;
	m_quality = 0.0;
	m_iNoOfRules = 0;
	m_iPlayerNo = 0;
	m_iPlayerType = 0;
	m_bHaveTeamname = FALSE;
	m_pwndToolBarRule = new CEditBar();
	m_bFirstShow = TRUE;
}

CMainFrame::~CMainFrame()
{
	delete m_pwndToolBarRule;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarMessages.Create(this) ||
		!m_wndToolBarMessages.LoadToolBar(IDR_TOOLBAR_MESSAGES))
	{
		TRACE0("Failed to create toolbar for messages\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarPerception.Create(this) ||
		!m_wndToolBarPerception.LoadToolBar(IDR_TOOLBAR_PERCEPTION))
	{
		TRACE0("Failed to create toolbar for perception\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarNetwork.Create(this) ||
		!m_wndToolBarNetwork.LoadToolBar(IDR_TOOLBAR_NETWORK))
	{
		TRACE0("Failed to create toolbar for network\n");
		return -1;      // fail to create
	}

/*	if (!m_wndToolBarRule.Create(this) ||
		!m_wndToolBarRule.LoadToolBar(IDR_TOOLBAR_RULE))
	{
		TRACE0("Failed to create toolbar for rulefile\n");
		return -1;      // fail to create
	}
*/
	if (!m_pwndToolBarRule->Init(this,TRUE, TRUE))
	{
		TRACE0("Failed to create editbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBarMessages.SetBarStyle(m_wndToolBarMessages.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBarPerception.SetBarStyle(m_wndToolBarPerception.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBarNetwork.SetBarStyle(m_wndToolBarNetwork.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
//	m_wndToolBarRule.SetBarStyle(m_wndToolBarRule.GetBarStyle() |
//		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_pwndToolBarRule->SetBarStyle(m_pwndToolBarRule->GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBarMessages.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBarPerception.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBarNetwork.EnableDocking(CBRS_ALIGN_ANY);
//	m_wndToolBarRule.EnableDocking(CBRS_ALIGN_ANY);
	m_pwndToolBarRule->EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_TOP);
//	DockControlBarLeftOf(&m_wndToolBarRule, &m_wndToolBar);
	DockControlBarLeftOf(m_pwndToolBarRule, &m_wndToolBar);
	DockControlBar(&m_wndToolBarMessages, AFX_IDW_DOCKBAR_BOTTOM);
	DockControlBarLeftOf(&m_wndToolBarPerception, &m_wndToolBarMessages);
	DockControlBar(&m_wndToolBarNetwork, AFX_IDW_DOCKBAR_RIGHT);

#ifdef NO_LUXUS
	ShowToolbars(FALSE);
#endif 

	return 0;
}

void CMainFrame::ActivateFrame(int nCmdShow)
	// nCmdShow is the normal show mode this frame should be in
{
	// translate default nCmdShow (-1)
	if (nCmdShow == -1)
	{
		if (!IsWindowVisible())
			nCmdShow = SW_SHOWNORMAL;
		else if (IsIconic())
			nCmdShow = SW_RESTORE;
	}

	if (m_bFirstShow)
		m_bFirstShow = FALSE;
	else
	{
		// bring to top before showing
		BringToTop(nCmdShow);

		if (nCmdShow != -1)
		{
			// show the window as specified
			ShowWindow(nCmdShow);

			// and finally, bring to top after showing
			BringToTop(nCmdShow);
		}
	}
}

void CMainFrame::ShowToolbars(BOOL bFlag)
{
	if (!bFlag)
	{
		// remove tool and status bar
		m_wndStatusBar.ShowWindow(SW_HIDE);
		m_wndToolBar.ShowWindow(SW_HIDE);
		m_wndToolBarMessages.ShowWindow(SW_HIDE);
		m_wndToolBarPerception.ShowWindow(SW_HIDE);
		m_wndToolBarNetwork.ShowWindow(SW_HIDE);
		m_pwndToolBarRule->ShowWindow(SW_HIDE);
	}
	else
	{
		// show tool and status bar
		m_wndStatusBar.ShowWindow(SW_SHOW);
		m_wndToolBar.ShowWindow(SW_SHOW);
		m_wndToolBarMessages.ShowWindow(SW_SHOW);
		m_wndToolBarPerception.ShowWindow(SW_SHOW);
		m_wndToolBarNetwork.ShowWindow(SW_SHOW);
		m_pwndToolBarRule->ShowWindow(SW_SHOW);
	}
}

void CMainFrame::DockControlBarLeftOf(CToolBar* Bar,CToolBar* LeftOf)
{
	CRect rect;
	DWORD dw;
	UINT n;

	// get MFC to adjust the dimensions of all docked ToolBars
	// so that GetWindowRect will be accurate
	RecalcLayout();
	LeftOf->GetWindowRect(&rect);
	rect.OffsetRect(1,0);
	dw=LeftOf->GetBarStyle();
	n = 0;
	n = (dw&CBRS_ALIGN_TOP) ? AFX_IDW_DOCKBAR_TOP : n;
	n = (dw&CBRS_ALIGN_BOTTOM && n==0) ? AFX_IDW_DOCKBAR_BOTTOM : n;
	n = (dw&CBRS_ALIGN_LEFT && n==0) ? AFX_IDW_DOCKBAR_LEFT : n;
	n = (dw&CBRS_ALIGN_RIGHT && n==0) ? AFX_IDW_DOCKBAR_RIGHT : n;

	// When we take the default parameters on rect, DockControlBar will dock
	// each Toolbar on a seperate line.  By calculating a rectangle, we in effect
	// are simulating a Toolbar being dragged to that location and docked.
	DockControlBar(Bar,n,&rect);
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.cx = 800;
	cs.cy = 600;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	if (!m_wndSplitter.CreateStatic(this, 2, 2))
		return FALSE;

	CRect rect;
	GetClientRect(&rect);
	CSize size;
	CSize size2 = rect.Size();
	
	size = size2;
	size.cx /= 3;
	size.cy /= 2;
	// view for the rules	
	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(TRuleView), size, pContext))
		return FALSE;

	// view for the network
	size.cx = size2.cx - size.cx;
	if (!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(TNetworkView), size, pContext))
		return FALSE;
	
	// view for the perceptions
	size.cy = size2.cy / 2;
	if (!m_wndSplitter.CreateView(1, 1, RUNTIME_CLASS(TPerceptionView), size, pContext))
		return FALSE;

	// view for the rules	
	size.cx = size2.cx - size.cx;
	if (!m_wndSplitter.CreateView(1, 0, RUNTIME_CLASS(CBasisView), size, pContext))
		return FALSE;
	
	SetActiveView((CView*)m_wndSplitter.GetPane(1, 1));
	return TRUE;	
}

void CMainFrame::OnTestRecieve() 
{
	CBasisDoc* pDoc = (CBasisDoc *)GetActiveDocument();
	ASSERT_VALID(pDoc);

//	pDoc->GetAgent()->ProcessPendingRead();
}

void CMainFrame::OnUpdateAction(CCmdUI *pCmdUI)
{
	CBasisDoc		*pDoc;

	pCmdUI->Enable();

	// get a pointer to the document
	pDoc = (CBasisDoc *) GetActiveDocument();

	// set the team's name
	if (pDoc->GetAgent() != NULL)
		pCmdUI->SetText(pDoc->GetAgent()->GetActionPerformedToString());
	else
		pCmdUI->SetText("initializing");
}

void CMainFrame::OnUpdateTeam(CCmdUI *pCmdUI)
{
	CBasisDoc		*pDoc;
	CString			oldName;

	pCmdUI->Enable();

	// get a pointer to the document
	pDoc = (CBasisDoc *) GetActiveDocument();

	// set the team's name (only once)
	if (!m_bHaveTeamname)
	{
		m_bHaveTeamname = TRUE;
		if (pDoc->GetAgent() != NULL)
			pCmdUI->SetText(pDoc->GetAgent()->GetTeam());
		else
			pCmdUI->SetText("Initializing");
	}
}

void CMainFrame::OnUpdatePlayer(CCmdUI *pCmdUI)
{
	CString			strRules;
	CBasisDoc		*pDoc;
	int				iPlayerNo;
	int				iPlayerType;

	pCmdUI->Enable();

	// get a pointer to the document
	pDoc = (CBasisDoc *) GetActiveDocument();

	// get the number of rules
	if (pDoc->GetAgent() != NULL)
	{
		iPlayerNo = pDoc->GetAgent()->GetNumber();
		iPlayerType = pDoc->GetAgent()->GetPlayerType();
		if ((iPlayerNo != m_iPlayerNo) || (iPlayerType != m_iPlayerType))
		{
			// set the new no of rules
			m_iPlayerNo = iPlayerNo;
			m_iPlayerType = iPlayerType;

			// set the new time text
			strRules.Format( "P %2d T %2d", m_iPlayerNo, m_iPlayerType ); 
			pCmdUI->SetText(strRules);
		}
		else if (pDoc->GetAgent()->IsCoach())
		{
			// set the new time text
			strRules = "Coach"; 
			pCmdUI->SetText(strRules);
		}
	}
	else
		pCmdUI->SetText("Initializing");
}

void CMainFrame::OnUpdateRules(CCmdUI *pCmdUI)
{
	CString			strRules;
	CBasisDoc		*pDoc;

	pCmdUI->Enable();

	// get a pointer to the document
	pDoc = (CBasisDoc *) GetActiveDocument();

	// get the number of rules
	if (pDoc->GetAgent() != NULL)
	{
		if (pDoc->GetAgent()->IsCoach())
		{
			// for coaches we show best quality
			double quality = ((TCoachAgent*)pDoc->GetAgent())->GetHighestQuality();
			if (quality > m_quality)
			{
				// set the new quality
				m_quality = quality;

				// set the new quality text
				strRules.Format( "%4.2f", m_quality); 
				pCmdUI->SetText(strRules);
			}
		}
		else
		{
			// for players we show the stamina
			int iStamina = pDoc->GetAgent()->GetStamina();
			if (iStamina != m_iStamina)
			{
				// set the new no of rules
				m_iStamina = iStamina;

				// set the new time text
				strRules.Format( "%4d", m_iStamina); 
				pCmdUI->SetText(strRules);
			}
		}
	}
	else
		pCmdUI->SetText("Initializing");

/*{
	CString			strRules;
	CBasisDoc		*pDoc;
	int				iRules;

	pCmdUI->Enable();

	// get a pointer to the document
	pDoc = (CBasisDoc *) GetActiveDocument();

	// get the number of rules
	iRules = pDoc->GetAgent()->GetNoOfRules();
	if (iRules != m_iNoOfRules)
	{
		// set the new no of rules
		m_iNoOfRules = iRules;

		// set the new time text
		strRules.Format( "%3d Rules", m_iNoOfRules ); 
		pCmdUI->SetText(strRules);

	}
*/
}

void CMainFrame::OnViewToolbarPerception() 
{
	if (m_wndToolBarPerception.IsWindowVisible())
		m_wndToolBarPerception.ShowWindow(SW_HIDE);
	else
		m_wndToolBarPerception.ShowWindow(SW_SHOW);
	RecalcLayout();
}

void CMainFrame::OnUpdateViewToolbarPerception(CCmdUI* pCmdUI) 
{
	if (m_wndToolBarPerception.IsWindowVisible())
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnComboSelection()
{
	CBasisDoc* pDoc = (CBasisDoc *)GetActiveDocument();
	ASSERT_VALID(pDoc);
	pDoc->InsertStringToRule(m_pwndToolBarRule->GetSelectedAction());
}

void CMainFrame::OnComboDropDown()
{
	CBasisDoc*		pDoc = (CBasisDoc *)GetActiveDocument();
	ASSERT_VALID(pDoc);
	
	pDoc->SetCombo(m_pwndToolBarRule->GetComboAction(), FALSE);
}

void CMainFrame::OnComboPerceptionSelection()
{
	CBasisDoc* pDoc = (CBasisDoc *)GetActiveDocument();
	ASSERT_VALID(pDoc);
	pDoc->InsertStringToRule(m_pwndToolBarRule->GetSelectedPerception());
}

void CMainFrame::OnComboPerceptionDropDown()
{
	CBasisDoc*		pDoc = (CBasisDoc *)GetActiveDocument();
	ASSERT_VALID(pDoc);
	
	pDoc->SetCombo(m_pwndToolBarRule->GetComboPerception(), TRUE);
}

void CMainFrame::OnViewAllBars() 
{
	if (m_wndToolBarNetwork.IsWindowVisible())
		ShowToolbars(FALSE);
	else
		ShowToolbars(TRUE);
	RecalcLayout();
}

void CMainFrame::OnUpdateViewAllBars(CCmdUI* pCmdUI) 
{
	if (m_wndToolBarNetwork.IsWindowVisible())
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}
