// TAccessMap.h: interface for the TAccessMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TACCESSMAP_H__EEFC89E1_EA99_11D3_A177_006008E88C8E__INCLUDED_)
#define AFX_TACCESSMAP_H__EEFC89E1_EA99_11D3_A177_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define ANGLE_STEP		5		// in degrees
#define NO_OF_ANGLES		72		// 360 / angle_step

#include "TVector.h"
#include "TDirection.h"

class TScreenParams;

/*-----------------------------------------------------------------------------
Class   : class TAccessMap  
Date    : 24.02.2000
-------------------------------------------------------------------------------
Base Class: none

Description: contains information on the area covered by an agent
-----------------------------------------------------------------------------*/

class TAccessMap  
{
	public:
		TAccessMap();
		virtual ~TAccessMap();

		void		Initialize(TVector pos, int iAbsViewDir, double dMaxDist = 105.0);
		void		AddPlayer(double dist, int dir, int bodyDir, BOOL isGoalie);
		void		AddPlayerDir(double dist, int dir);
		void		DrawMap(CDC* pDC, TScreenParams *tScreen);
		void		SetParameters(double kickableMargin, double playerSize);

		int		GetIndexFromAngle(int angle);
		int		GetAbsIndexFromIndex(int index);
		int		GetAngleFromIndex(int index);
		double	GetDistanceFromIndex(int index);
		BOOL		AddNewDistance(int index, double dist);
		void		AddFieldDistance(int index, double dist, int iCosIndex);

	private:

		int		NormalizeIndex(int &index);
		void		GetCoordinates(TScreenParams* tScreen, double dx, double dy, int &x, int &y);
		
		double		m_dAccess[NO_OF_ANGLES];
		double		m_dCos[NO_OF_ANGLES];
		TVector		m_tPos;
		TDirection	m_tViewDir;

		double		m_kickableMargin;
		double		m_playerSize;
};

#endif // !defined(AFX_TACCESSMAP_H__EEFC89E1_EA99_11D3_A177_006008E88C8E__INCLUDED_)
