// TDirection.h: interface for the TDirection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TDIRECTION_H__8A4CF8A1_F53F_11D1_A16C_006008E88C8E__INCLUDED_)
#define AFX_TDIRECTION_H__8A4CF8A1_F53F_11D1_A16C_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/*-----------------------------------------------------------------------------
Class   : TDirection
Date    : 27.05.98
-------------------------------------------------------------------------------
Base Class: CObject

Description: does the calculation of angles
-----------------------------------------------------------------------------*/

class TDirection// : public CObject  
{
	public:
		TDirection() {  m_iDirection = 0; };
		TDirection(int dir) { m_iDirection = dir; CheckRange(); };
		TDirection(TDirection& dir) { m_iDirection = dir.GetDirection(); };
		//		TDirection(double dir) { m_iDirection = (int) dir; CheckRange(); };
		virtual ~TDirection() {};

		void			CheckRange(void);
		int			GetDirection(void) const { return m_iDirection; };
		TDirection	Abs(void);
		BOOL			LiesWithin(TDirection& dir1, TDirection& dir2);
		BOOL			IsLeftOf(TDirection& dir2);
		BOOL			IsRightOf(TDirection& dir2);

		friend TDirection operator+ (int val1, TDirection& val2);
		friend TDirection operator+ (TDirection& val1, int val2);
		friend TDirection operator+ (TDirection& val1, TDirection& val2);
		friend TDirection operator- (int val1, TDirection& val2);
		friend TDirection operator- (TDirection& val1, int val2);
		friend TDirection operator- (TDirection& val1, TDirection& val2);
		friend TDirection operator* (int val1, TDirection& val2);
		friend TDirection operator* (TDirection& val1, int val2);
		BOOL operator == (const TDirection& val) { return (m_iDirection == val.GetDirection()); };
		BOOL operator == (int val) { return (m_iDirection == val); };
		BOOL operator > (const TDirection& val) { return (m_iDirection > val.GetDirection()); };
		BOOL operator > (int val) { return (m_iDirection > val); };
		BOOL operator < (const TDirection& val) { return (m_iDirection < val.GetDirection()); };
		BOOL operator < (int val) { return (m_iDirection < val); };
		BOOL operator >= (const TDirection& val) { return (m_iDirection >= val.GetDirection()); };
		BOOL operator >= (int val) { return (m_iDirection >= val); };
		BOOL operator <= (const TDirection& val) { return (m_iDirection <= val.GetDirection()); };
		BOOL operator <= (int val) { return (m_iDirection <= val); };
		
		TDirection operator = (const TDirection& val) { return TDirection(m_iDirection = val.GetDirection()); };
		TDirection operator = (int val) { m_iDirection = val; CheckRange(); return TDirection(m_iDirection); };
		TDirection operator = (double val) { m_iDirection = (int) val; CheckRange(); return TDirection(m_iDirection); };

		const TDirection& operator += (const TDirection& val) { m_iDirection += val.GetDirection(); CheckRange(); return *this; };
		const TDirection& operator += (int val) { m_iDirection += val; CheckRange(); return *this; };
		const TDirection& operator -= (const TDirection& val) { m_iDirection -= val.GetDirection(); CheckRange(); return *this; };
		const TDirection& operator -= (int val) { m_iDirection -= val; CheckRange(); return *this; };
		const TDirection& operator *= (const TDirection& val) { m_iDirection *= val.GetDirection(); CheckRange(); return *this; };
		const TDirection& operator *= (int val) { m_iDirection *= val; CheckRange(); return *this; };
		const TDirection& operator /= (TDirection& val) { m_iDirection /= val.GetDirection(); CheckRange(); return *this; };
		const TDirection& operator /= (int val) { m_iDirection /= val; CheckRange(); return *this; };

		operator int() { return m_iDirection; };
		operator double() { return (double) m_iDirection; };
			
	private:

		int	m_iDirection;
};

#endif // !defined(AFX_TDIRECTION_H__8A4CF8A1_F53F_11D1_A16C_006008E88C8E__INCLUDED_)
